package com.jpa;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;


@Entity
@NamedQueries({
	@NamedQuery(
			name = "Organisation.findByName", 
			query = "SELECT o FROM Organisation o WHERE o.name = :name"),
	@NamedQuery(
			name = "Organisation.findByName.joinFetch", 
			query = "SELECT o FROM Organisation o LEFT JOIN FETCH o.person WHERE o.name = :name")
})
public class Organisation {

	public static final String TABLE_CREATE = "create table ORGANISATION (id int not null, name varchar(32), person_id int)";
	
	@Id
	@GeneratedValue
	private long id;
	
	private String name;

	@ManyToOne(cascade=CascadeType.ALL, fetch=FetchType.LAZY)
	private Person person;

	public Person getPerson() {
		return person;
	}

	public void setPerson(Person person) {
		this.person = person;
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
}